-- some pure Lua 5.1 bitwise operations blogged by RiciLake
-- 8 .... 2 1

function bit(p)
  return 2 ^ (p - 1)  -- 1-based indexing
end

-- Typical call:  if hasbit(x, bit(3)) then ...
function hasbit(x, p)
  return x % (p + p) >= p       
end

function hasbit_ex (x,p)
  if hasbit(x, p)  then 
   return 1
  end
 return 0
end

function setbit(x, p)
  return hasbit(x, p) and x or x + p
end

function clearbit(x, p)
  return hasbit(x, p) and x - p or x
end